struct GraphStruct
/******************************************************************************/
/* Struktur zur Speicherung eines gerichteten oder ungerichteten Graphen als  */
/* Adjazenzliste. Alle Indizierungen beginnen bei 0.                          */
/******************************************************************************/
  {
    unsigned   directed;       /* 1 fuer gerichtete, 0 fuer unger. Graphen    */
    unsigned   nodenumber;     /* Anzahl Knoten                               */
    unsigned   edgenumber;     /* Anzahl Kanten                               */
    unsigned * adjacentnumber; /* Feld der Laenge nodenumber, in dem zu jedem */
                               /* Knoten (numeriert von 0 bis nodenumber-1)   */
                               /* die Anzahl der adjazenten Knoten steht.     */
    unsigned * adjacentfirst;  /* Feld der Laenge nodenumber, in dem zu jedem */
                               /* Knoten (numeriert von 0 bis nodenumber-1)   */
                               /* die Stelle des ersten adjazenten Knoten im  */
                               /* Feld adjacentlist steht.                    */
    unsigned * adjacentlist;   /* Feld der Laenge edgenumber (2*edgenumber    */
                               /* bei unger. Graphen), in dem von Stelle ad-  */
                               /* jacentfirst[i] bis Stelle adjacentfirst[i]  */
                               /* +adjacentnumber[i]-1 die Nummern der zum    */
                               /* Knoten i adjazenten Knoten stehen.          */
  };
typedef struct GraphStruct Graph;
 

struct ComponentStruct
/******************************************************************************/
/* Struktur zur Speicherung von starken Zusammenhangskomponenten (bzw. Zusam- */
/* menhangskomp. bei unger. Graphen). Alle Indizierungen beginnen bei 0.      */
/******************************************************************************/
  {
    unsigned   directed;         /* 1 fuer gerichtete, 0 fuer unger. Graphen  */
    unsigned   componentnumber;  /* Anzahl Komponenten                        */
    unsigned   nodenumber;       /* Anzahl Knoten                             */
    unsigned * componentsize;    /* Feld der Laenge componentnumber, in dem   */
                                 /* zu jeder Komponente (numeriert von 0 bis  */
                                 /* componentnumber-1) die Anzahl der Knoten  */
                                 /* in der Komponente steht.                  */
    unsigned * nodefirst;        /* Feld der Laenge componentnumber, in dem   */
                                 /* zu jeder Komponente die Stelle des ersten */
                                 /* Knoten dieser Komponente im Feld nodelist */
                                 /* steht.                                    */
    unsigned * nodelist;         /* Feld der Laenge nodenumber, in dem von    */
                                 /* Stelle nodefirst[i] bis nodefirst[i]      */
                                 /* +componentsize[i]-1 die Nummern der zur   */
                                 /* Komponente i gehoerenden Knoten stehen.   */
  };
typedef struct ComponentStruct Component;
